<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use App\Models\User;
use App\Models\GroupModel;

class AddUser extends Command {

    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'user:add {login : xlogin z UIS } {--admin : Nastavit jako admina}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Přidat uživatele UIS k uživatelům systému Morpheus';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct() {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle() {
        $admin = $this->option('admin');
        $login = $this->argument('login');
        $user_duplicity = User::where('login',$login)->first();
        if (empty($user_duplicity)) {
            $new_user = new User;
            $new_user->login = $login;
            $new_user->admin = $admin;
            if ( $new_user->save()){
                $this->info('Uživatel vytvořen');
            } else {
                $this->info('Někde se stala chyba, uživatele se nepodařilo vložit');
            }
        } else {
            $this->info('Uzivatel jiz existuje');
        }
        
    }

}
