<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use App\Models\User;
use App\Models\GroupModel;

class ListUser extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'user:list';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Vypsání všech uživatelů, včetně adminů a lokálních';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $admin_local = User::where('login','admin_local')->first();
        $this->info('lokální admin');
        if(isset($admin_local)){
            $this->info('-'.$admin_local->login);
        }
        $admins = User::where('admin',true)->get();
        $this->info('admini');
        foreach($admins as $admin){
            $this->info('-'.$admin->login);
        }
        $users = User::where('admin',false)->get();
        $this->info('uživatelé');
        foreach($users as $user){
            $this->info('-'.$user->login);
        }
        
        
    }
}
