<?php

namespace App\Console;

use App\Models\RuleModel;
use App\Models\CommandModel;
use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;
use SoapClient;

class Kernel extends ConsoleKernel {

    /**
     * The Artisan commands provided by your application.
     *
     * @var array
     */
    protected $commands = [
        Commands\Inspire::class,
        Commands\AddUser::class,
        Commands\RemoveUser::class,
        Commands\ListUser::class,
    ];

    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule) {
        // * * * * * Johny /var/www/html/chat/chat/artisan schedule:run >> /dev/null 2>&1

        $schedule->call(function() {
            date_default_timezone_set('Europe/Prague');
            $day_of_week = date('D'); // Mon
            $time = date('G:i');

            $tasks = RuleModel::with('computersIncluded.computerName')
                    ->where($day_of_week, TRUE)
                    ->where('active', TRUE)
                    ->where('time', $time)
                    ->get();

            if (sizeof($tasks) >0 ) {
                $url = "http://krtecek.mendelu.cz/morpserver/server.php";
                $client = new SoapClient(null, array(
                    'location' => $url,
                    'uri' => "morpheus",
                    'trace' => 1
                        )
                );

                foreach ($tasks as $task) {
                    $computers_for_task = array();
                    $computers = ' ';
                    for ($i = 0; $i < sizeof($task['computersIncluded']); $i++) {
                        array_push($computers_for_task, $task['computersIncluded'][$i]['computerName']['name']);
                        $computers = $computers . ' ' . $task['computersIncluded'][$i]['computerName']['name']; 
                    }
                    $command = CommandModel::find($task->command_id);
                    shell_exec('logger -t morpheus -i -p local0.info " CRON Zacina ulohu - command: ' . $command->content . ' | computers: ' . $computers . ' > /dev/null &"');
                    if ($command->content == 'ZAP') {
                        $client->wakeUp($computers_for_task);
                    } else if($command->content == 'VYP') {
                        $client->shutdown($computers_for_task);
                    } else{
                        $client->doCom($computers_for_task,$command->content);
                    }    
                }
            }
        })->everyMinute();
    }

}
