<?php

namespace App\Exceptions;

use Exception;
use Illuminate\Validation\ValidationException;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use Symfony\Component\HttpKernel\Exception\HttpException;
use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;

class Handler extends ExceptionHandler {

    /**
     * A list of the exception types that should not be reported.
     *
     * @var array
     */
    protected $dontReport = [
        AuthorizationException::class,
        HttpException::class,
        ModelNotFoundException::class,
        ValidationException::class,
    ];

    /**
     * Report or log an exception.
     *
     * This is a great spot to send exceptions to Sentry, Bugsnag, etc.
     *
     * @param  \Exception  $e
     * @return void
     */
    public function report(Exception $e) {
        parent::report($e);
    }

    /**
     * Render an exception into an HTTP response.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Exception  $e
     * @return \Illuminate\Http\Response
     */
    public function render($request, Exception $e) {
        $msg = "ldap_bind(): Unable to bind to server: Can't contact LDAP server";
        $msg1 = 'ldap_bind(): Unable to bind to server: Invalid credentials';
        if ($e->getMessage() ==  $msg) {   
            return redirect('/login')->withErrors(['login'=>$request->login,'msg'=>'Ldap není připojen']);
        }else if($e->getMessage() == $msg1){
            return redirect('/login')->withErrors(['login'=>$request->login,'msg'=>'Špatné jméno, nebo heslo']);
        }
        else{
            return parent::render($request, $e);
        }

        
    }

}
