<?php

/*
|--------------------------------------------------------------------------
| Routes File
|--------------------------------------------------------------------------
|
| Here is where you will register all of the routes in an application.
| It's a breeze. Simply tell Laravel the URIs it should respond to
| and give it the controller to call when that URI is requested
|
*/
Route::group(['middleware' => ['web']], function () {
//login
Route::get('/login', ['as' => 'login', 'uses' => 'LoginController@loginForm']);
Route::get('/logout', ['as' => 'logout', 'uses' => 'LoginController@logout']);
Route::post('/auth/login', 'LoginController@login');

Route::group(['middleware' => ['auth']], function () {
//main page
Route::get('/', ["as" => "home", "uses" => "GridController@getHomeView"]);
Route::get('/pullinfo',['as' => 'reload','uses' => 'ComputerController@computerInfo']);
Route::post('/change_power_state',['uses' => 'ComputerController@changePowerState']);
Route::get('/available_commands',['as' => 'available_commands','uses' => 'ComputerController@getCommandList']);
Route::get('/save_command',['uses' => 'ComputerController@saveCommand']);
Route::get('/delete_command',['uses' => 'ComputerController@deleteCommand']);
Route::post('/userlog',['uses' => 'ComputerController@userLog']);
Route::post('/userlog_pef',['uses' => 'ComputerController@userLogPef']);
Route::post('/command',['uses' => 'ComputerController@doCommand']);
Route::post('/delprofile',['uses' => 'ComputerController@delProfile']);

//rules
Route::get('/rules/pullrules',['as' => 'pullrules','uses' => 'RuleController@getRules']);
Route::post('/rules/addrule',['uses' => 'RuleController@addRule']);
Route::post('/rules/modifyrule',['uses' => 'RuleController@modifyRule']);
Route::delete('/rules/deleterule',['uses' => 'RuleController@deleteRule']);

//administration
Route::get('/permissions',['as' => 'permissions','uses' => 'AdminController@getPermView']);
Route::get('/permissions/user',['uses' => 'AdminController@getUserInfo']);
Route::get('/permissions/modifyuser',['uses' => 'AdminController@modifyUser']);

Route::get('/colouring',['as' => 'colouring','uses' => 'AdminController@getColouringView']);
Route::get('/colouring/add_colouring',['as' => 'add_colouring','uses' => 'AdminController@addColouring']);
Route::get('/colouring/del_colouring',['as' => 'del_colouring','uses' => 'AdminController@delColouring']);

//test
Route::get('/ldap',['uses' => 'Auth\LdapController@getUserPass']);
Route::get('/adrule',['as' => 'adrules','uses' => 'ComputerController@getComp']);

});
});
/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| This route group applies the "web" middleware group to every route
| it contains. The "web" middleware group is defined in your HTTP
| kernel and includes session state, CSRF protection, and more.
|
 * 
 * Route::group(['middleware' => ['web']], function () {
    
 
});

*/

