<?php

namespace App\Models;

use Illuminate\Contracts\Auth\Authenticatable;
use Illuminate\Database\Eloquent\Model;

/*
 * Vlastní user class
 */

class User extends Model implements Authenticatable {

    protected $table = 'user';

    /**
     * @return string
     */
    public function getAuthIdentifierName() {
        // Return the name of unique identifier for the user (e.g. "id")
        return 'login';
    }

    /**
     * @return mixed
     */
    public function getAuthIdentifier() {
        // Return the unique identifier for the user (e.g. their ID, 123)
        return $this->attributes['login'];
    }

    /**
     * @return string
     */
    public function getAuthPassword() {
        // Returns the (hashed) password for the user
        return 'null';
    }

    /**
     * @return string
     */
    public function getRememberToken() {
        // Return the token used for the "remember me" functionality
        return $this->attributes['remember_token'];
    }

    /**
     * @param  string  $value
     * @return void
     */
    public function setRememberToken($value) {
        $this->attributes['remember_token'] = $value;
    }

    /**
     * @return string
     */
    public function getRememberTokenName() {
        // Return the name of the column / attribute used to store the "remember me" token
        return 'remember_token';
    }

    public function isAdmin() {
        return $this->attributes['admin'];
    }

}
