<?php

namespace App\Policies;

use Illuminate\Auth\Access\HandlesAuthorization;
use App\Models\RightModel;

class BasicPolicy {

    use HandlesAuthorization;

    /**
     * Create a new policy instance.
     *
     * @return void
     */
    public function __construct() {
        //
    }

    private function getPermission($user, $permission) {
        $rights = RightModel::where('user_id', $user->id)->with('getType')->get();
        foreach ($rights as $right) {
            if ($right->getType->name == $permission) {
                return true;
            }
        }
        return false;
    }

    public function before($user) {
        if ($user->isAdmin()) {
            return true;
        }
    }

    /*
     * Uživatelské role oprávnění aplikace
     */

    public function PcSwitch($user) {
        return $this->getPermission($user, 'Správa napájení');
    }

    public function PcCommands($user) {
        return $this->getPermission($user, 'Administrace PC');
    }

    public function TestSystem($user) {
        return $this->getPermission($user, 'Testovací systém');
    }

    public function RulesEdit($user) {
        return $this->getPermission($user, 'Správa pravidel');
    }

    //////////////////////////////////////////////////////////
}
