<?php

namespace App\Providers;

use App\Models\User;
use Illuminate\Contracts\Auth\Authenticatable;
use Illuminate\Contracts\Auth\UserProvider as IlluminateUserProvider;

/*
 * Vlastní user provider
 */

class UserProvider implements IlluminateUserProvider {

    /**
     * @param  mixed  $identifier
     * @return \Illuminate\Contracts\Auth\Authenticatable|null
     */
    public function retrieveById($identifier) {
        // Get and return a user by their unique identifier
        $user = User::where('login', $identifier)->first();
        if (!empty($user)) {
            return $user;
        } else {
            return new User;
        }
    }

    /**
     * @param  mixed   $identifier
     * @param  string  $token
     * @return \Illuminate\Contracts\Auth\Authenticatable|null
     */
    public function retrieveByToken($identifier, $token) {
        // Get and return a user by their unique identifier and "remember me" token
    }

    /**
     * @param  \Illuminate\Contracts\Auth\Authenticatable  $user
     * @param  string  $token
     * @return void
     */
    public function updateRememberToken(Authenticatable $user, $token) {
        // Save the given "remember me" token for the given user
    }

    /**
     * Retrieve a user by the given credentials.
     *
     * @param  array  $credentials
     * @return \Illuminate\Contracts\Auth\Authenticatable|null
     */
    public function retrieveByCredentials(array $credentials) {
        // Get and return a user by looking up the given credentials
        $user = User::where('login', $credentials['login'])->first();
        if (!empty($user)) {
            return $user;
        } else {
            return new User;
        }
    }

    /**
     * Validate a user against the given credentials.
     *
     * @param  \Illuminate\Contracts\Auth\Authenticatable  $user
     * @param  array  $credentials
     * @return bool
     */
    public function validateCredentials(Authenticatable $user, array $credentials) {
        $username = $user->login;
        $password = $credentials['password'];

        //bcrypt - 
        if ($username == 'admin_local' && password_verify($password, '')) {
            return true;
        }


        if (isset($username)) {
            $conn = ldap_connect(config('auth.ldap.server')) or die("Could not connect");
            if ($conn) {
                ldap_set_option($conn, LDAP_OPT_PROTOCOL_VERSION, 3);

                if (ldap_bind($conn, "uid=" . $username . ", ou=People,dc=mendelu,dc=cz", $password)) {
                    return true;
                } else {
                    return false;
                }
            } else {
                ldap_close($conn);
            }
        }
    }

}
