<?php

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateRuleTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('rules',function(Blueprint $table){
            $table->increments('id');
            $table->string('name');
            $table->time('time');
            $table->integer('command_id');
            $table->foreign('command_id')->references('id')->on('command')->onDelete('cascade');
            $table->boolean('class');
            $table->boolean('active');
            $table->boolean('Mon');
            $table->boolean('Tue');
            $table->boolean('Wed');
            $table->boolean('Thu');
            $table->boolean('Fri');
            $table->boolean('Sat');
            $table->boolean('Sun');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('rules');
    }
}