var pc_selected; // pole vybraných počítačů, které se odešle při kliknutí na akci(zapnuti)
var class_active; // aktivní učebna
var available_commands; // příkazy které lze odeslat na klienty(název a obsah)

$(document).ready(function () {
    pc_selected = [];
    class_active = '';

    initPage();

    // inicializace ajaxu, nastavení loaderu
    $('#loader').hide();
    $.ajaxSetup({
        beforeSend: function () {
            $('#loader').show();
        },
        complete: function () {
            $('#loader').hide();
        },
        success: function () {
        }
    });

    // přepínání ovládacího panelu a obsahu na správu a pravidla
    $('.show_maintain').click(function (e) {
        $('#rules_page').hide();
        $('#main_page').show();
    });

    $('.show_rules').click(function (e) {
        $('#rules_page').show();
        $('#main_page').hide();
        pullRules();
    });

    // Manipulace s počítači - eventy na tlačítkách v control panelu
    $('#power_on').click(function () {
        changePowerState($(this).attr('id'));
    });

    $('#power_off').click(function () {
        changePowerState($(this).attr('id'));
    });

    $('#refresh').click(function () {
        pullInfo(class_active);
        changeActiveAll('', 'unselect_all');
    });

    $('#del_profile').click(function () {
        delProfile();
        changeActiveAll('', 'unselect_all');
    });

    $('#userlog').submit(function (e) {
        e.preventDefault();
        var user = $('input[name=user]').val();
        var pass = $('input[name=pass]').val();
        userLog(user, pass);
        $('#loginModal').modal("toggle");
        changeActiveAll('', 'unselect_all');
    });

    $('#login_pef').click(function () {
        userLogPef();
        changeActiveAll('', 'unselect_all');
    });

    $('#command_open').click(function () {
        getAvailableCommands();
        $('#commandsModal input').hide();
        $('#save_command').hide();
        $('#commandsModal select').show();
        $('#add_command').show();
        $('#modify_command').hide();
        $('#delete_command').hide();
    });

    $('#add_command').click(function () {
        $('#commandsModal select').hide();
        $('#commandsModal input').show();
        $('#add_command').hide();
        $('#save_command').show();
        $('#commandsModal textarea').val('');
        $('input[name=command_id]').val('new');
    });

    $('#save_command').click(function () {
        var name = $('#commandsModal input[type=text]').val();
        var content = $('#commandsModal textarea').val();
        var id = $('input[name=command_id]').val();
        saveCommand(name, content, id);
    });

    $('#modify_command').click(function () {
        var name = $('#commandsModal select option:selected').val();
        $('#commandsModal select').hide();
        $('#commandsModal input').show();
        $('#commandsModal input').val(name);
        $('#add_command').hide();
        $('#save_command').show();
        $('#modify_command').hide();
        $('#delete_command').hide();
        $('input[name=command_id]').val($('#commandsModal select option:selected').attr('data-id'));
    });

    $('#delete_command').click(function () {
        if (window.confirm('Opravdu smazat příkaz? Tímto smažete i pravidla s touto akcí')) {
            deleteCommand($('#commandsModal select option:selected').attr('data-id'));
        }
    });

    $('#commandsModal select').click(function () {
        if ($(this).val() !== 'default') {
            $('#modify_command').show();
            $('#delete_command').show();
            $('#add_command').hide();
            for (var i = 0; i < available_commands.length; i++) {
                if (available_commands[i].name == $('#commandsModal select option:selected').val()) {
                    $('#commandsModal textarea').val(available_commands[i].content);
                }
                ;
            }
            ;
        } else {
            $('#add_command').show();
            $('#commandsModal textarea').val('');
            $('#modify_command').hide();
            $('#delete_command').hide();
        }
    });

    $('#send_command').click(function (e) {
        e.preventDefault();
        var command = $('textarea').val();
        sendCommand(command);
        $('#commandsModal').modal("toggle");
        changeActiveAll('', 'unselect_all');
    });

    //vyjížděcí sidebar
    $("#menu-toggle").click(function (e) {
        e.preventDefault();
        $("#wrapper").toggleClass('toggled');
    });

    //Manipulace s výběrem (označování) počítačů
    $("div[data-computer]").click(function () {
        changeActive($(this));
    });

    $("div[data-nick]").click(function () {
        showClass($(this).data('nick'));
    });

    $(".vyber_ucebnu").click(function () {
        changeActiveAll($(this).parent().children('div').data('nick'), 'select');
    });

    $(".odeber_ucebnu").click(function () {
        changeActiveAll($(this).parent().children('div').data('nick'), 'unselect');
    });

    $("#odeber_vse").click(function () {
        changeActiveAll('', 'unselect_all');
    });
    $(".sidebar-nav li").mouseover(function () {
        $(this).children('img').show();
    });

    $(".sidebar-nav li").mouseout(function () {
        $(this).children('img').hide();
    });

});
///////////////////////////////////////////////////////////////////////////////////
// FUNKCE
//////////////////////////////////////////////////////////////////////////////////

// Označení a odznačení všech počítačů v učebně, operace: [select | unselect | unselect_all(smaže všechny označené)]
function changeActiveAll(ucebna, operace) {
    if (operace === 'select') {
        $("div[data-computer=" + ucebna + "]").each(function () {
            selectPc($(this));
            $(this).addClass('selected');
        });
    } else if (operace === 'unselect') {
        $("div[data-computer=" + ucebna + "]").each(function () {
            unSelectPc($(this));

            $(this).removeClass('selected');
        });
    } else if (operace === 'unselect_all') {
        $("div[data-computer]").removeClass('selected');
        pc_selected = [];
    }
    updatePocet();
}

// po kliknutí na počítač ho přidá, nebo odebere z výběru
function changeActive(but) {
    if (but.hasClass("selected")) {
        but.removeClass("selected");
        unSelectPc(but);
    } else {
        but.addClass("selected");
        selectPc(but);
    }

    updatePocet();
}

// přepočítá seznam vybraných pc v sidebaru dle mřížky, kde počítače vybírám
function updatePocet() {
    $(".sidebar-nav li div").each(function () {
        var ucebna = $(this).data('nick');
        var pocet = $(".selected[data-computer=" + ucebna + "]").length;
        $(this).children().text(pocet);
        if (pocet > 0) {
            $(this).css("font-weight", "bold");
        } else
        {
            $(this).css("font-weight", "normal");
        }
    });
}

// zobrazí počítače zadané učebny v mžížce (obsahu)
function showClass(ucebna) {
    class_active = $("#" + ucebna + ".row").data('nazev');
    $('#ucebna-nick').text(' : ' + $('div[data-nick=' + ucebna + ']').data('nickname'));
    $("#aktual-ucebna > b").text(class_active);
    $(".sidebar-nav").children('li').removeClass('active');
    $("div[data-nick=" + ucebna + "]").parent().addClass('active');
    $("#page-content-wrapper > .row").hide();
    $("#" + ucebna + ".row").show();
    var delka = $("#" + ucebna + "").data("width");
    if (delka < 5) {
        delka = 5;
    }
    $(".botmenu").removeClass().addClass("botmenu col-lg-" + delka + " col-md-7 col-xs-12");
    pullInfo(ucebna);
}

// přídá počítač do vektoru vybraných počítačů
function selectPc(pc) {
    var pocitac = [];
    pocitac['name'] = pc.data('nazev');
    pocitac['room'] = pc.data('computer');
    var pridej = true;
    for (var i = 0; i < pc_selected.length; i++) {
        if (pocitac['name'] === pc_selected[i]['name']) {
            pridej = false;
        }
    }
    if (pridej) {
        pc_selected.push(pocitac);
    }
}
// odebere počítač z vktoru vybraných počítačů
function unSelectPc(pc) {
    var konec = pc_selected.length - 1;
    var pocitac = pc.data('nazev');
    for (var i = 0; i < pc_selected.length; i++) {
        if (pocitac === pc_selected[i]['name']) {
            pc_selected[i] = pc_selected[konec];
            pc_selected.pop();
        }
    }
    console.log(pc_selected);
}

// ajaxové volání - zobrazí stav počítačů v učebně
function pullInfo(ucebna) {

    $.ajax({
        dataType: "json",
        url: "pullinfo",
        method: "GET",
        data: {
            ucebna: ucebna
        },
        success: function (data) {
            updatePcInfo(data.data);
        },
        error: function (data) {
            flashError(data);
        }

    });

}

// zobrazí stav počítače 
function updatePcInfo(data) {

    for (var i = 0; i < data.length; i++) {
        var aktual = $('div[data-nazev=' + data[i].nazev + ']');
        aktual.attr('class', data[i].dostupnost);
        aktual.children('div').text(data[i].prihlaseny);
        aktual.children('div').attr('class', data[i].group);
        aktual.children('h4').children('i').attr('class', data[i].system);
        //kontrola jestli je pc vybrany
        for (var j = 0; j < pc_selected.length; j++) {
            if (data[i].nazev === pc_selected[j]['name']) {
                aktual.addClass('selected');
            }
        }
    }
}

// odeslání zapnutí a vypnutí pc
function changePowerState(command) {
    var computers = divideArray(pc_selected, 'name');
    var classes = divideArray(pc_selected, 'room');
    $.ajax({
        dataType: "json",
        url: "change_power_state",
        method: "POST",
        data: {
            computers: computers,
            classes: classes,
            command: command
        },
        success: function (data) {
            changeActiveAll('', 'unselect_all');
            flashSuccess(data.msg);
        },
        error: function (data) {
            flashError(data);
            console.log(data);
        }
    });
}

// přihlášení vzdáleného uživatele
function userLog(user, pass) {
    var computers = divideArray(pc_selected,'name');
    var classes = divideArray(pc_selected,'room');
    $.ajax({
        dataType: "json",
        url: "userlog",
        method: "POST",
        data: {
            user: user,
            pass: pass,
            computers: computers,
            classes: classes
        },
        success: function (msg) {
            changeActiveAll('', 'unselect_all');
            flashSuccess(msg.msg);
        },
        error: function (msg) {
            flashError(msg);
        }
    });

}

// smazání dat profilů vybraných pc
function delProfile() {
    var computers = divideArray(pc_selected, 'name');
    var classes = divideArray(pc_selected, 'room');
    $.ajax({
        dataType: "json",
        url: "delprofile",
        method: "POST",
        data: {
            computers: computers,
            classes: classes
        },
        success: function (msg) {
            changeActiveAll('', 'unselect_all');
            flashSuccess(msg.msg);
        },
        error: function (msg) {
            flashError(msg);
        }
    });
}

// režim přijímačky
function userLogPef() {
    var computers = divideArray(pc_selected, 'name');
    var classes = divideArray(pc_selected, 'room');
    $.ajax({
        dataType: "json",
        url: "userlog_pef",
        method: "POST",
        data: {
            computers: computers,
            classes: classes
        },
        success: function (msg) {
            changeActiveAll('', 'unselect_all');
            flashSuccess(msg.msg);
        },
        error: function (msg) {
            flashError(msg);
        }
    });

}

// odeslat příkaz
function sendCommand(command) {
    var computers = divideArray(pc_selected, 'name');
    var classes = divideArray(pc_selected, 'room');
    $.ajax({
        dataType: "json",
        url: "command",
        method: "POST",
        data: {
            command: command,
            computers: computers,
            classes: classes

        },
        success: function (msg) {
            changeActiveAll('', 'unselect_all');
            flashSuccess(msg.msg);
        },
        error: function (msg) {
            flashError(msg);
        }
    });

}

// zobrazí dostupné příkazy
function getAvailableCommands() {
    $.ajax({
        dataType: "json",
        url: "available_commands",
        method: "GET",
        data: {
        },
        success: function (data) {
            $('#commandsModal select option').not('option:first').remove();
            available_commands = data.commands;
            for (var i = 0; i < data.commands.length; i++) {
                var option = $('<option></option>');
                option.text(data.commands[i].name);
                option.attr('data-id', data.commands[i].id);
                if (data.commands[i].name !== 'Vypnout pc' && data.commands[i].name !== 'Zapnout pc') {
                    $('#commandsModal select').append(option);
                }
            }
        },
        error: function (msg) {
            flashError(msg);
        }
    });
}

// uložení nového příkazu
function saveCommand(name, content, id) {
    $.ajax({
        dataType: "json",
        url: "save_command",
        method: "GET",
        data: {
            name: name,
            content: content,
            id: id
        },
        success: function () {
            getAvailableCommands();
            $('#commandsModal input').hide();
            $('#save_command').hide();
            $('#commandsModal select').show();
            $('#add_command').show();
            $('#commandsModal textarea').val('');
        },
        error: function (msg) {
            flashError(msg);
        }
    });
}

// smazání příkazu
function deleteCommand(id) {
    $.ajax({
        dataType: "json",
        url: "delete_command",
        method: "GET",
        data: {
            id: id
        },
        success: function () {
            getAvailableCommands();
            $('#add_command').show();
            $('#commandsModal textarea').val('');
            $('#modify_command').hide();
            $('#delete_command').hide();
        },
        error: function (msg) {
            flashError(msg);
        }
    });
}

// zobrazení počítačů pro první učebnu v sidebaru
function initPage() {
    var first_menu_item = $('.sidebar-nav').children().eq(0);
    if (first_menu_item.length === 0) {
        alert('kontaktujte spravce pro prideleni práv');
    } else {
        showClass(first_menu_item.children().eq(0).data('nick'));
        updatePocet(first_menu_item.children().eq(0).data('nick'));
    }
}

// zobrazení zpráv
function flashError(message) {
    $('#message').attr('class', 'alert alert-danger').text(message.responseText).fadeIn(200).fadeOut(2000);
}
function flashSuccess(message) {
    $('#message').attr('class', 'alert alert-success').text(message).fadeIn(200).fadeOut(2000);
}

// vybraný počítač obsahuje pole s indexem 'name' a 'room', nelze odeslat ajaxem toto dvourozm. pole, takze se musi rozdelit na samostatne dve pole
function divideArray(pc_selected, index) {
    var output = [];
    for (var i = 0; i < pc_selected.length; i++) {
        output.push(pc_selected[i][index]);
    }
    return output;
}



