$(document).ready(function () {

    getUserProperty($('#selectuser option:selected').val());

    $(".sidebar-nav li").mouseover(function () {
        $(this).children('img').show();
    });

    $(".sidebar-nav li").mouseout(function () {
        $(this).children('img').hide();
    });


    $(".vyber_ucebnu").click(function () {
        $(this).parent().addClass('bold');
    });

    $(".odeber_ucebnu").click(function () {
        $(this).parent().removeClass('bold');
    });

    $("#odeber_vse").click(function () {
        $('.sidebar-nav').children().each(function () {
            $(this).removeClass('bold');
        });
    });

    $('#selectuser').change(function (e) {
        e.preventDefault();
        $('.sidebar-nav').children().each(function () {
            $(this).removeClass('bold');
        });
        $('input[type=checkbox]').attr('checked', false);
        getUserProperty($('#selectuser option:selected').val());
    });

    $('button[name=modify]').click(function (e) {
        e.preventDefault();
        var id = $('#selectuser option:selected').val();
        var rights = [];
        var rooms = [];
        $('input[type=checkbox]').each(function () {
            if ($(this).prop('checked') === true) {
                rights.push($(this).val());
            }
        });
        $('.sidebar-nav').children().each(function () {
            if ($(this).hasClass('bold')) {
                rooms.push($(this).children().eq(0).data('nick'));
            }
        });

        modifyUserProperty(id, rights, rooms);
    });


});

// zobrazí povolené učebny v sidebaru
function refreshRooms(rooms) {
    for (var i = 0; i < rooms.length; i++) {
        var room = rooms[i].get_room.name;
        $('div[data-nick=' + room + ']').parent().addClass('bold');
    }
}

// zobrazí práva v selectu
function refreshRights(rights) {
    for (var i = 0; i < rights.length; i++) {
        var right = rights[i].right_type_id;
        $("input[value=" + right + "]").prop('checked', true);
    }
}

// stažení přístupů a práv uživatele
function getUserProperty(id) {
    $.ajax({
        dataType: "json",
        url: "permissions/user",
        method: "GET",
        data: {
            id: id
        },
        success: function (data) {
            refreshRooms(data.rooms);
            refreshRights(data.rights);
        }

    });

}

// modifikace práv a učeben
function modifyUserProperty(id, rights, rooms) {
    console.log(id, rights, rooms);
    $.ajax({
        dataType: "json",
        url: "permissions/modifyuser",
        method: "GET",
        data: {
            id: id,
            rights: rights,
            rooms: rooms
        },
        success: function (data) {
            getUserProperty(id);
            flashSuccess(data.msg);
        }

    });

    function flashError(message) {
        $('#message').attr('class', 'alert alert-danger').text(message.responseText).fadeIn(200).fadeOut(2000);
    }
    function flashSuccess(message) {
        $('#message').attr('class', 'alert alert-success').text(message).fadeIn(200).fadeOut(2000);
    }


}


