var rules_includes_pc; // obsahuje pole objektů(objekt obsahuje id pravidla a pole s názvy počítačů tohoto pravidla)

$(document).ready(function () {
    rules_includes_pc = [];


    $.ajaxSetup({
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        }
    });

    // uložení pravidla
    $('#save_pravidlo').click(function () {
        addRule($(this));
    });

    // znovunačtení pravidel z backendu
    $('#refresh_pravidla').click(function () {
        pullRules();
    });

    // zobrazí rozhraní pro vytvoření pravidla
    $("#pridej_pravidlo").click(function () {
        $('.nove_pravidlo').fadeIn();
        getAvailableCommandsToRule($('select[name=command]'));
    });

    // označování dnů v týdnu
    $("td div").click(function () {
        $(this).toggleClass('date_active');

    });

});
///////////////////// FUNKCE///////////////////////

/// stáhne všechna pravidla a zavolá jejich vykreslení
function pullRules() {
    $.ajax({
        dataType: "json",
        url: "rules/pullrules",
        method: "GET",
        success: function (rules) {
            $('#vsechna_pravidla').empty();
            rules_includes_pc = [];
            for (var i = 0; i < rules.rules.length; i++) {
                makeRule(rules.rules[i]);
            }
        }
    });
}

// vytvoření a přidání položky do seznamu pravidel
// vstup je objekt(jedno pravidlo) s atributy: id,pauza,class,time,active,name,days
// volám při načtení všech pravidel a při vytvořeni nového pravidla
function makeRule(rule) {
    // pokud má pravidlo s sebou počítače, tak ho přidám do pole, kde tyto počítače eviduji
    if (rule.hasOwnProperty('computers_included')) {
        var pc_included = [];
        for (var i = 0; i < rule.computers_included.length; i++) {

            pc_included.push(rule.computers_included[i].computer_name.name);

        }
        var list = {computers: pc_included, rule: rule.id};
        rules_includes_pc.push(list);
    }
    // vytvořím objekt pravidla s html tagy, který vložím do DOMu
    var dny = ['po', 'ut', 'st', 'ct', 'pa', 'so', 'ne'];
    var polozka = $(" <tr data-id='" + rule.id + "' class='" + rule.pause + "'><td>" + rule.class + "</td><td>" + rule.time + "</td><td data-command_id='" + rule.command_id + "'>" + rule.command + "</td><td>" + rule.name + "</td></tr>").click(renderComputersIncludedInRules);
    var td = $("<td>");
    var lock = $("<span style='width:270px;height:40px;display:block;margin:0px;padding:0px;position:absolute;margin-top:-3px;'></span>");// překrytí dnů - zamezení editace
    td.append(lock);
    for (var j = 0; j < dny.length; j++) { // přidání aktivních dnů v týdnu
        var div = $("<div>");
        div.addClass(rule[dny[j]]);
        div.text(dny[j].toUpperCase());
        div.data("date", dny[j]);
        div.click(function () {
            $(this).toggleClass("date_active");
        });
        td.append(div);

    }
    polozka.append(td);
    var controls = $("<td class='modif'>"); // přidání tlačítek pro manipulaci s pravidlem
    var del_button = $("<img class='delete_rule' src='" + window.location.href + "/icons/delete.svg'>").click(deleteRule);
    var mod_button = $("<img class='modify_rule' src='" + window.location.href + "/icons/upravit.svg'>").click(renderComputersIncludedInRules).click(modifyRule);
    var pause_button = $("<img class='" + rule.tlacitko + "' src='" + window.location.href + "/icons/" + rule.tlacitko + ".svg'>").click(modifyRuleState);
    var save_button = $("<img class='save_rule' src='" + window.location.href + "/icons/save.svg'>").hide().click(function () {
        sendModifyRule($(this));
    });
    var cancel_button = $("<img class='cancel_rule' src='" + window.location.href + "/icons/cancel.svg'>").hide().click(function () {
        pullRules();
    });
    controls.append(del_button).append(mod_button).append(pause_button).append(save_button).append(cancel_button);
    $('#vsechna_pravidla').prepend(polozka);
    $('#vsechna_pravidla tr').first().fadeOut().fadeIn();
    $('#vsechna_pravidla tr').first().append(controls);

}

// vykresli počítače toho pravidla, na které kliknu
// vyberu si je z vektoru rules_includes_pc
function renderComputersIncludedInRules() {
    changeActiveAll('', 'unselect_all');
    var rule_id = $(this).parent().parent().data('id');
    if (rule_id == null) {
        rule_id = $(this).data('id');
    }
    for (var i = 0; i < rules_includes_pc.length; i++) {

        if (rules_includes_pc[i].rule === rule_id) {
            for (var j = 0; j < rules_includes_pc[i].computers.length; j++) {
                changeActive($("div[data-nazev=" + rules_includes_pc[i].computers[j] + "]"));
            }
        }
    }
}

// smazání pravidla
function deleteRule() {
    var id = $(this).parent().parent().data('id');
    $.ajax({
        dataType: "json",
        url: "rules/deleterule",
        method: "delete",
        data: {
            id: id
        },
        success: function (msg) {
            flashSuccess(msg.msg);
            console.log(msg);
        },
        error: function (msg) {
            flashError(msg);
        }
    });
    $(this).parent().parent().hide();
    changeActiveAll('', 'unselect_all');
}

// zjistí parametry a odešle nové pravidlo, vstup je prvek, na který klikneme
function addRule(rule) {
    var kdy = rule.parent().parent().find('input[name=kdy]').val();
    var command_id = rule.parent().parent().find('select[name=command] option:selected').attr('data-id');
    var nazev = rule.parent().parent().find('input[name=nazev]').val();
    var days = [];
    rule.parent().parent().find('div[data-date]').each(function () {
        if ($(this).hasClass('date_active')) {
            days.push(1);
        } else {
            days.push(0);
        }
    });
    if (command_id > 0) { // kontrola, zda není vybrána neplatná hodnota, pokud je v selectu vybráno "Vyber příkaz", tak je hodnota "default"
        computers = divideArray(pc_selected, 'name'); // viz. computer.js
        classes = divideArray(pc_selected, 'room');
        $.ajax({
            dataType: 'json',
            url: 'rules/addrule',
            method: 'POST',
            data: {
                kdy: kdy,
                command_id: command_id,
                nazev: nazev,
                days: days,
                computers: computers,
                classes: classes
            },
            success: function (rules) {
                makeRule(rules.rules[0]);
                $('.nove_pravidlo').hide();
                changeActiveAll('', 'unselect_all');
            },
            error: function (xhr, msg) {
                console.log(xhr);
                flashError(msg);
            }
        });
    }
}
// odemče pravidlo pro úpravy
function modifyRule() {
    var input_kdy = $('<input name="kdy" size="5" maxlength="5" type="text">').val($(this).parent().siblings().eq(1).text());
    var input_name = $('<input name="nazev" size="20" type="text"></td>').val($(this).parent().siblings().eq(3).text());
    var select_value = $(this).parent().siblings().eq(2).text();
    var select_command = $('<select name="command"></select>');
    getAvailableCommandsToRule(select_command, select_value);
    $(this).parent('.modif').children().hide();
    $(this).parent('.modif').children('.save_rule').show();
    $(this).parent('.modif').children('.cancel_rule').show();
    $(this).parent().siblings().eq(1).html(input_kdy);
    $(this).parent().siblings().eq(3).html(input_name);
    $(this).parent().siblings().eq(2).html(select_command);
    $(this).parent().siblings().eq(4).children('span').hide();



}
// odešle provedené změny v pravidle, parametr je tlačítko na ktere kliklu (this)
// volám i když zapínám a zastavuji pravidlo
function sendModifyRule(rule) {
    var active = rule.parent().parent().attr('class');
    var id = rule.parent().parent().data('id');
    var kdy = rule.parent().parent().find('input[name=kdy]').val();
    //pokud volám zastavení pravidla, tak jsou hodnoty v jiných html prvcích
    if (!kdy) {
        kdy = rule.parent().siblings().eq(1).text();
    }
    var nazev = rule.parent().parent().find('input[name=nazev]').val();
    if (!nazev) {
        nazev = rule.parent().siblings().eq(3).text();
    }
    var command_id = rule.parent().parent().find('select[name=command] option:selected').attr('data-id');
    if (!command_id) {
        command_id = rule.parent().siblings().eq(2).attr('data-command_id');
    }
    // kontrola vybraných dnů
    var days = [];
    rule.parent().parent().children().eq(4).children('div').each(function () {
        if ($(this).hasClass('date_active')) {
            days.push(1);
        } else {
            days.push(0);
        }
    });

    computers = divideArray(pc_selected, 'name');
    $.ajax({
        dataType: 'json',
        url: 'rules/modifyrule',
        method: 'POST',
        data: {
            id: id,
            kdy: kdy,
            command_id: command_id,
            active: active,
            nazev: nazev,
            days: days,
            computers: computers
        },
        success: function (rules) {
            var path = window.location.href + "/icons/" + rules.rules[0].tlacitko + ".svg";
            //aktualizace upraveného pravidla v seznamu (pro jistotu se vrátí z backendu)
            rule.parent().parent().attr('class', rules.rules[0].pause);
            rule.parent().siblings().eq(1).html(rules.rules[0].time);
            rule.parent().siblings().eq(2).html(rules.rules[0].command);
            rule.parent().siblings().eq(3).html(rules.rules[0].name);
            rule.parent().children().eq(2).attr('src', path);
            rule.parent().siblings().eq(4).children('span').show();
            // přidání počítačů do vektoru v rules_includes_pc
            for (var i = 0; i < rules_includes_pc.length; i++) {
                if (rules_includes_pc[i].rule === rules.rules[0].id) {
                    rules_includes_pc[i].computers = [];
                    var pc_included = [];
                    for (var j = 0; j < rules.rules[0].computers_included.length; j++) {
                        pc_included.push(rules.rules[0].computers_included[j].computer_name.name);
                    }
                    rules_includes_pc[i].computers = pc_included;
                }
            }
        },
        error: function (xhr, msg) {
            console.log(xhr);
            flashError(msg);
        }
    });
    // vrátím zpět ikony
    rule.parent('.modif').children().attr('style', '');
    rule.parent('.modif').children('.save_rule').hide();
    rule.parent('.modif').children('.cancel_rule').hide();
}

// zapnutí a vypnutí pravidla
function modifyRuleState() {
    $(this).parent().parent().toggleClass('pravidlo_pause');
    sendModifyRule($(this));
}

// při vytváření a modifikaci pravidla se do prvku select přidají dostupné příkazy
// vstup: select - html prvek do kterého vkládám optiony
//        active - při modifikaci se zjistí, jaký command je nastavený a označí se v následném selectu
function getAvailableCommandsToRule(select, active) {
    $.ajax({
        dataType: "json",
        url: "available_commands",
        method: "GET",
        data: {
        },
        success: function (data) {
            select.children('option').not('option[value=default]').remove();
            for (var i = 0; i < data.commands.length; i++) {
                var option = $('<option></option>');
                option.text(data.commands[i].name);
                option.attr('data-id', data.commands[i].id);
                option.val(data.commands[i].name);
                if (data.commands[i].name == active) {
                    option.attr('selected', 'selected');
                }
                select.append(option);
            }
        },
        error: function () {
        }
    });
}



