﻿# Morpheus - postup instalace
---------------------------
1. Aplikace je uložena na gitu - https://bitbucket.org/lysek/morpheus.git - tam se ale nedostanete bez účtu a oprávnění.
	Proto bude prozatím kopie uložena na serveru krtecek.mendelu.cz v adresáři \var\www\html\morpheus\export.
2. Konfigurace souboru .env - přejmenovat .env.example na .env a editovat položky DB_HOST, DB_USERNAME, DB_PASSWORD
3. Instalace Composeru na serveru + v adresáři s aplikací spustit příkaz composer install
4. Nastavení oprávnění, příkaz `chmod -R 777 /storage /bootstrap/cache`
5. Kontrola nastavení klíče v souboru .env - řádek APP_KEY musí mít nastavený klíč, jinak v kořenovém 
	adresáři aplikace spustit příkaz `php artisan key:generate`
6. Nastavit pro Apache Vhosta, s nastavením AllowOverride All 
7. Vytvoření schéma databáze - příkaz `php artisan migrate` - musí projít bez chyb, jinak je databáze špatně nastavena
8. Naplnění databáze - příkaz `php artisan db:seed`
9. Správa uživatelů - lokální účet, který je přístupný bez ldapu: admin_local
	* Uživatelé se spravují pomocí konzole, lze vypsat nápovědu příkazem `php artisan list` a popis parametrů příkazu 
	* pomocí `php artisan help [příkaz]` 
	* Přidání uživatele do aplikace: `php artisan user:add [--admin] xlogin` -přepínač admin přidělí nejvyšší práva
	* Odebrání uživatele aplikace: `php artisan user:remove xlogin`
	* Přehled uživatelů a jejich skupin: `php artisan user:list`
10. Provádění pravidel aplikace potřebuje záznam v cronu: `* * * * * root /var/www/html/morpheus/artisan schedule:run >> /dev/null 2>&1`

Více informací lze zjistit zde -
https://laravel.com/docs/5.2/installation

# Administrátorský manuál
-----------------------
1. Připojení aplikace k API

	Aplikace je závislá na přesně definovaném rozhraní a datech z API. Toto nastavení je potřeba v aplikaci změnit
	ve dvou souborech. První místo obsluhuje stahování informací o počítačích a volání funkcí, tj.
	/app/Http/Controllers/Controller_api.php. Druhé místo slouží k automatickému provádění pravidel, tj.
	/app/Console/Kernel.php. V obou případech musíme nastavit URL (lokaci), URI (namespace) a trace na hodnotu 1.

2. Správa vstupu uživatelů do aplikace

	K ověřování přihlašovaných uživatelů je použit adresářový server LDAP, ale i bez jeho připojení může admin pracovat
	na lokálním účtu, který má automaticky všechna práva. Nastavení adresy serveru LDAP lze měnit v /config/auth.php 'ldap' => 'server'.
        Manuální ověření lokálního uživatele(admin_local) najdeme v souboru /app/Providers/UserProvider.php. 

 3. Postup přidání nové role oprávnění

	*  Přidání role do aplikace

		První krok pro přidání je vytvoření záznamu v databázi - tabulka right_type, zde přidáme název role.
		V tuto chvíli se již role zobrazí v nastavení oprávnění aplikace. Následně je třeba upravit třídu
		BasicPolicy v souboru /app/Policies/BasicPolicy.php. Zde registrujeme novou metodu. Její název zvolíme
		libovolně, nejlépe zkratkou názvu nové role. Implementace funkce lze jednoduše odvodit z 
		ostatních rolí v této třídě. Tímto je registrována nová role oprávnění ve frameworku a je možné
		je přidělovat uživatelům systému.

	*  Stanovení funkce role

		Po registraci role je potřeba specifikovat, na které části a funkce aplikace se toto oprávnění vztahuje 
		(typicky nová funkcionalita). Toto je třeba řešit na úrovni šablon a kontrolleru. Na úrovni šablon v 
		případě přidání funkčního tlačítka s novou akcí v rámci naší role se tlačítko uzavře do direktivy s 
		následující syntaxí: `@can("zkratka oprávnění", Auth::user()) <tlačítko> @endcan`. Toto tlačítko se zobrazí 
		jen uživateli s touto přiřazenou rolí. Dále je třeba zkontrolovat, zda má uživatel oprávnění také při 
		volání kontrolleru, protože toto volání lze udělat i ručně bez použití grafického prvku
		(přístupem na danou routu). V kontrolleru se kontrola práv zavolá v implementační části s podmínkou:
		`if($this->authorize("zkratka oprávnění", Auth::user())){implementace}`. Pro omezení přístupu na celou
		konkrétní stránku(šablonu) lze výše uvedenou podmínkou v kontroleru zamezit vracení šablony uživatelům 
		bez práv a přesměrovat je na jinou adresu.

4. Postup ošetření chybových stavů počítače z API

	Pro indikaci chybového stavu některého z parametrů počítače slouží v grafickém rozhraní vykreslení oranžovou 
	barvou(css styl pocitac-error). Kontrola se provádí pro každý počítač v metodě computerInfo třídy 
	ComputerController(tj. při načtení celé učebny). V této metodě nalezneme volání funkce `checkComputerErrorState()`,
	ta má defaultně dva parametry - autologin počítače a přihlášený uživatel. V této funkci vyhodnocujeme tyto vstupy,
	zda jsou korektní a pokud nejsou, tak vrací false a počítač se označí oranžově. Je zde prostor pro kontrolu dalších
	parametrů počítače z API, stačí přidat další parametr této funkci a dosadit za něj výstup z API v 
	podobě: `$result[$i]["parametr počítače"]`. V implementaci definovat chybový stav a následné vracení hodnoty true.

5. Přidání tlačítka do ovládacího panelu

	Ovládací panel lze rozšířit o další akce nad vybranými počítači. To lze udělat dle následujícího postupu:

	*  Nahrajeme požadovanou ikonu do složky /public/icons
	*  Přidáme tlačítko do šablony main.blade.php v podobě html tagu <img> s vybranou ikonou a identifikátorem
	*  Zvolíme roli oprávnění, tzn. kterým uživatelům tlačítko zpřístupníme
	*  Vytvoříme onclick událost na tlačítko v javascriptu - soubor /public/js/Computer.js
	*  V události vytvoříme ajaxový požadavek typu POST, data budou obsahovat minimálně proměnnou computers a classes
	kvůli logování. Jejich obsah získáme funkcí divideArray. `var computers = divideArray(pc_selected, 'name')` 
	- obsahuje vybrané počítače. `var classes = divideArray(pc_selected, 'room')` - obsahuje vybrané učebny.
	*  Vytvoříme routu typu POST v /app/Http/routes.php, kterou budeme volat
	*  Přidáme metodu do kontroleru a naimplementujeme ji