@extends('layouts.static')
@section('title','Správa obarveni')

@section('head')
<script type="text/javascript" src="{{asset('/js/colouring.js')}}"></script>
<style>
    #page-content-wrapper, #page-content-wrapper a,#page-content-wrapper a:hover,#page-content-wrapper a:visited{
        color:black;
    }
    #wrapper{
        padding-left:50px;
    }
    .bold{
        font-weight: bold;
    }
    .box{
        width:300px;
        height:300px;
        float:left;
        margin-right: 20px;
        padding: 0px 10px 0 10px;
    }
    #cervena{
        background-color: lightcoral;
    }
    #modra{
        background-color: lightblue;
    }
    #select_admin {
        background-color: lightcoral;
        height:200px;
        color:black;
    }
    #select_testy{
        background-color: lightblue;
        height:200px;
        color:black;
    }
    input[type=text]{
        width:200px;
        margin:10px 0 0 0;
        display: inline;
    }
    .btn{
        background-color: #009688;
        color:white;
    }


</style>

@endsection

@section('menu')
<li><a href="{{route('home')}}"><img src="{{asset('/icons/back.svg')}}"></a></li>
<li><a href="{{route('permissions')}}">Oprávnění</a></li>
<li><a href="{{route('colouring')}}"><b>Podbarvení uživatelů</b></a></li>
@endsection


@section('content')
<h2>Barevně zvýraznení uživatelé</h2>
<hr>
<div class="box" id="cervena">
    <h4>Admins</h4>
    <select data-group_id="{{$admins_id}}" class="form-control" multiple id='select_admin'>
        @foreach($admins as $admin)
        <option value="{{$admin['user']}}">{{$admin['user']}}</option>
        @endforeach
    </select>
    <input placeholder="login" class="form-control" name="admin_login" type="text">
    <input type="hidden" name="admin_group_id" value="{{$admins_id}}">
    <button class="btn" name="new_admin">+</button>
    <button class="btn" name="del_admin">-</button>
</div>
<div class="box" id="modra">
    <h4>Testy</h4>
    <select data-group_id="{{$testy_id}}" class="form-control" multiple id='select_testy'>
        @foreach($tests as $test)
        <option value="{{$test['user']}}">{{$test['user']}}</option>
        @endforeach
    </select>
    <input class="form-control" placeholder="login" name="testy_login" type="text">
    <input type="hidden" name="testy_group_id" value="{{$testy_id}}">
    <button class="btn" name="new_testy">+</button>
    <button class="btn" name="del_testy">-</button>
</div>


</br></br>


@endsection



