<!DOCTYPE html>
<html lang="cs">
    <head>
        <meta charset="UTF-8">
        <script src="{{asset('/js/jquery-2.2.3.min.js')}}"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js" integrity="sha384-0mSbJDEHialfmuBBQP6A4Qrprq5OVfW37PRR3j5ELqxss1yVqOtnepnHVP9aJ7xS" crossorigin="anonymous"></script>
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.1/css/font-awesome.min.css">
        <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="stylesheet" href="{{asset('/css/bootstrap.min.css')}}">
        <link rel="stylesheet" href="{{asset('/css/styly.css')}}">
        <link rel="stylesheet" href="{{asset('/css/sidebar.css')}}">
        <meta name="csrf-token" content="{{ csrf_token() }}" />
        @yield('head')

        <title>Morpheus - @yield('title')</title>
    </head>
    <body>

        <nav>
            <ul>
                @yield('menu')
            </ul>
            <ul id="right_nav">
                @can('PermissionsChange',Auth::user())
                <li><a href="{{route('permissions')}}"><img src="{{asset('/icons/settings.svg')}}"></a></li>
                @endcan
                <li><a href="{{route('logout')}}">Odhlásit <b> {{Auth::user()->login}}</b> </a></li>
            </ul>


        </nav>

        <div id="wrapper">
            
            @yield('sidebar')

            <div id="page-content-wrapper">
                <div id="message" class="alert" role="alert"></div>
                @yield('content')

            </div>

        </div>

    </body>
</html>