@extends('layouts.with_sidebar')
@section('title','Správa počítačů')

@section('content')
@include('computers')

<div id="main_page" class="botmenu col-md-10 col-xs-12">
    @can('RulesEdit',Auth::user())
    <div class='changemode active_mode show_maintain'>Správa</div>
    <div class="changemode show_rules">Pravidla</div>
    @endcan
    @can('PcCommands',Auth::user())
    <img id="del_profile" title="del_profile" src="{{asset('/icons/del_profile.svg')}}">
    <img data-toggle="modal" id="command_open" title="send_command" data-target="#commandsModal" src="{{asset('/icons/command.svg')}}">
    <img data-toggle="modal" title="login_user" data-target="#loginModal" src="{{asset('/icons/login.svg')}}">
    @endcan
    @can('TestSystem',Auth::user())
    <img class="odsaz" title="login_pef" id="login_pef" src="{{asset('/icons/login_pef.svg')}}">
    @endcan
    @can('PcSwitch',Auth::user())
    <img id="refresh" title="refresh_class" src="{{asset('/icons/refresh.svg')}}">
    <img id="power_off" title="power_off" src="{{asset('/icons/poweroff.svg')}}">
    <img id="power_on" title="power_on" src="{{asset('/icons/power.svg')}}">
    @endcan
</div>

@can('RulesEdit',Auth::user())
<div id="rules_page">

    <div class="botmenu col-md-10 col-xs-12">
    <div class='changemode show_maintain'>Správa</div>
    <div class="changemode active_mode show_rules">Pravidla</div>
        <img id="pridej_pravidlo" src="{{asset('/icons/add.svg')}}">
        <img id="refresh_pravidla" src="{{asset('/icons/refresh.svg')}}">

    </div>

    <div class="rules_container col-md-6 col-xs-12">

        <h3 class="nove_pravidlo">Nové pravidlo</h3>
        <table class="table nove_pravidlo">

            <tr><td>
                
                </td>
                <td>
                    <input name="kdy" size="4" maxlength="5" value="0:00" type="text">
                </td>
                <td>
                    <select name="command"><option  data-id='0' value="default">Vyber příkaz</option></select>
                </td>
                <td>
                    <input name="nazev" size="16" placeholder="Název pravidla" type="text">
                </td>
                <td>
                    <div data-date>PO</div><div data-date>UT</div><div data-date>ST</div><div data-date>CT</div>
                    <div data-date>PA</div><div data-date>SO</div><div data-date>NE</div>
                </td>
                <td>
                    <img id="save_pravidlo" style="display:inline" src="{{asset('/icons/save.svg')}}">
                </td>
            </tr>
        </table>

        <h3>Všechna pravidla</h3>
        <table id="vsechna_pravidla" class="table">
        </table>

    </div>
</div>
@endcan

<!-- modal login-->
<div class="modal fade" id="loginModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
    <div class="modal-dialog modal-sm" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="myModalLabel">Zadejte login a heslo</h4>
            </div>
            <div id="modalContent" class="modal-body">

                <form id="userlog" method="post">
                    <div class="form-group">
                        <input type="text" class="form-control" name="user" placeholder="User">
                    </div>
                    <div class="form-group">
                        <input type="password" class="form-control" name="pass" placeholder="Heslo">
                    </div>
                    <button id="login_user" type="submit" class="btn btn-success pull-right">Přihlásit</button>
                </form>

            </div>

        </div>
    </div>
</div>

<!-- modal commands-->

<div class="modal fade" id="commandsModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <img align="right" id="add_command" src="{{asset('/icons/add.svg')}}">
                <img align="right" id="save_command" src="{{asset('/icons/save.svg')}}">
                <img align="right" id="modify_command" src="{{asset('/icons/upravit.svg')}}">
                <img align="right" id="delete_command" src="{{asset('/icons/delete.svg')}}">
                <h4 class="modal-title" id="myModalLabel">Spouštění příkazů</h4>
            </div>
            <div style="height:260px;" class="modal-body">
                Příkaz:
                <select class="form-control">
                    <option value="default">Vyber příkaz</option>
                </select>
                <input type="hidden" name="command_id" value="">
                <input name="command_name" type="text">
                <form id="command" method="post">
                    <textarea cols="105" rows="8">
                      
                    </textarea>
                    <button id="send_command" type="submit" class="btn btn-success pull-right">Odeslat příkaz</button>
                </form>

            </div>

        </div>
    </div>
</div>




@endsection