@extends('layouts.static')
@section('title','Správa oprávnění')

@section('menu')
<li><a href="{{route('home')}}"><img src="{{asset('/icons/back.svg')}}"></a></li>
<li><a href="{{route('permissions')}}"><b>Oprávnění</b></a></li>
<li><a href="{{route('colouring')}}">Podbarvení uživatelů</a></li>
@endsection

@section('head')
<script type="text/javascript" src="{{asset('/js/administration.js')}}"></script>
<style>
    #page-content-wrapper, #page-content-wrapper a,#page-content-wrapper a:hover,#page-content-wrapper a:visited{
        color:black;
    }
    #wrapper{
        padding-left:250px;
    }
    .bold{
        font-weight: bold;
    }
    #form_div{
        width:300px;
    }
    input[type=checkbox]{
        width:20px;
        height:20px;
    }
    #form_div span{
        line-height: 20px;
    }
    label{
        margin-bottom: 0px;
    }
    button[name=modify]{
        background-color: #009688;
        color:white;
    }

</style>

@endsection


@section('sidebar')
<div id="sidebar-wrapper">
    <div id="sidebar-heading">
        <h2>Práva učeben</h2>
        <img id="odeber_vse" src="{{asset('/icons/unselect.svg')}}">
    </div>
    <ul class="sidebar-nav">

        @foreach($classes as $class)
        <li>
            <div data-nick="{{$class['nazev']}}">{{$class['nazev']}} </div>
            <img class="odeber_ucebnu" src="{{asset('/icons/unselect.svg')}}">
            <img class="vyber_ucebnu" src="{{asset('/icons/select.svg')}}">
        </li>

        @endforeach
    </ul>


</div>
@endsection

@section('content')
<h2>Přístupy uživatelů do učeben</h2><hr>
<div id="form_div">
    <select class="form-control" id='selectuser'>
        @foreach($users as $user)
        <option value="{{$user['id']}}">{{$user['login']}}</option>
        @endforeach
    </select>
</div>
</br>
@foreach($rights as $right)
<input type="checkbox" value="{{$right['id']}}" name="{{$right['name']}}"><label for="{{$right['name']}}">{{$right['name']}}</label></br>
@endforeach
</br>
<button class="btn" name="modify">Ulož změny</button>



@endsection

